// D1100 DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "D1100 Demo.h"
#include "D1100 DemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CD1100DemoDlg dialog

CD1100DemoDlg::CD1100DemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CD1100DemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CD1100DemoDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pFrameBuffer = NULL;
	m_pByteArray = NULL;
	toggle=0;

}

void CD1100DemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CD1100DemoDlg)
	DDX_Control(pDX, IDC_DDC1100CTRLCTRL1, m_D1100_Index1);
	DDX_Control(pDX, IDC_DDC1100CTRLCTRL2, m_D1100_Index2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CD1100DemoDlg, CDialog)
	//{{AFX_MSG_MAP(CD1100DemoDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTONTILOGO, OnButtontilogo)
	ON_BN_CLICKED(IDC_BUTTONTILOGO2, OnButtonDLPLogo)
	ON_BN_CLICKED(IDC_BUTTONTOGGLE, OnButtontoggle)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CD1100DemoDlg message handlers

BOOL CD1100DemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	OpenD1100(1);	//open D1100 #1 USB
	OpenD1100(2);	//open D1100 #2 USB
	
	if (m_pByteArray)
		{
		delete m_pByteArray;
		m_pByteArray = NULL;
		}
	m_pByteArray = new CByteArray;	// create image storage byte array
	m_pByteArray->SetSize (1024 * 768 / 8);
	m_pFrameBuffer=new COleVariant (*m_pByteArray);	//convert to variant pointer

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CD1100DemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CD1100DemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CD1100DemoDlg::OpenD1100 (int DeviceIndex)
{
    BOOL bRtn = TRUE;
	CDDC1100Ctrl *m_pDDCControl;

	if (DeviceIndex==1)
		m_pDDCControl=&m_D1100_Index1;	// use instance 1
	else if (DeviceIndex==2)
		m_pDDCControl=&m_D1100_Index2;	// use instance 2
	else
		{
		AfxMessageBox (_T("Invalid Device Index"));
		return FALSE;
		}

	// Initialize device 
    if (!m_pDDCControl->GetDeviceMulti(DeviceIndex))	
    {
        AfxMessageBox (_T("Error communicating with the Discovery 1100 "));
        bRtn = FALSE;
   }
    else
    {
        m_pDDCControl->EnableParallel (0);
    }


    return (bRtn);
}

void CD1100DemoDlg::OnButtontilogo() 
{
	ShowImage(1,"TILOGO.bmp");	//instance 1
	ShowImage(2,"TILOGO.bmp");	//instance 2
}

void CD1100DemoDlg::OnButtonDLPLogo() 
{
	ShowImage(1,"DLPLOGO.bmp");	//instance 1
	ShowImage(2,"DLPLOGO.bmp");	//instance 2
}

BOOL CD1100DemoDlg::ShowImage(int DeviceIndex,LPCTSTR lpFilename) 
{
	CDDC1100Ctrl *m_pDDCControl;

	if (DeviceIndex==1)
		m_pDDCControl=&m_D1100_Index1;	// use instance 1
	else if (DeviceIndex==2)
		m_pDDCControl=&m_D1100_Index2;	// use instance 2
	else
		{
		AfxMessageBox (_T("Invalid Device Index"));
		return FALSE;
		}


	if (!m_pDDCControl->IsDeviceAttached ())
	{
		AfxMessageBox (_T("Error communicating with the Discovery 1100"));
		return FALSE;
	}
	else
	{
		// load image into memory buffer m_pFrameBuffer in DMD compatible format
		m_pDDCControl->LoadImageFileToBuffer(lpFilename,m_pFrameBuffer,0);
		// transfer image from memory buffer to ActiveX control buffer
		m_pDDCControl->LoadFrameBuffer(m_pFrameBuffer);
		// load and reset to display the image
		m_pDDCControl->LoadResetFrame ();	// display the image
	}

	return TRUE;
	
}


void CD1100DemoDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

void CD1100DemoDlg::OnButtontoggle() 
{
	toggle++;	//inc toggle counter
	toggle%=2;

	if (toggle)	
		{
		ShowImage(1,"TILOGO.bmp");	
		ShowImage(2,"DLPLOGO.bmp");	
		}
	else
		{
		ShowImage(1,"DLPLOGO.bmp");	
		ShowImage(2,"TILOGO.bmp");	
		}
	
}
