// D1100 DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "D1100 Demo.h"
#include "D1100 DemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CD1100DemoDlg dialog

CD1100DemoDlg::CD1100DemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CD1100DemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CD1100DemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pFrameBuffer = NULL;
	m_pByteArray = NULL;

}

void CD1100DemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CD1100DemoDlg)
	DDX_Control(pDX, IDC_DDC1100CTRLCTRL1, m_D1100);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CD1100DemoDlg, CDialog)
	//{{AFX_MSG_MAP(CD1100DemoDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTONTILOGO, OnButtontilogo)
	ON_BN_CLICKED(IDC_BUTTONTILOGO2, OnButtonDLPLogo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CD1100DemoDlg message handlers

BOOL CD1100DemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	OpenD1100();	// inti D1100
	

	// create image storage buffer m_pByteArray and variant point m_pFrameBuffer
	if (m_pByteArray)
		{
		delete m_pByteArray;
		m_pByteArray = NULL;
		}
	m_pByteArray = new CByteArray;
	m_pByteArray->SetSize (1024 * 768 / 8);
	m_pFrameBuffer=new COleVariant (*m_pByteArray);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CD1100DemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CD1100DemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


// Open D1100 device
BOOL CD1100DemoDlg::OpenD1100 ()
{
    BOOL bRtn = FALSE;

	// Initialize the device
    if (!m_D1100.GetDevice())	
    {
        AfxMessageBox (_T("Error communicating with the Discovery 1100"));
    }
    else
    {
        m_D1100.EnableParallel (0);	//set D1100 to USB mode
        bRtn = TRUE;
    }

    return (bRtn);
}

void CD1100DemoDlg::OnButtontilogo() 
{
	ShowImage("TILOGO.bmp");	
}

void CD1100DemoDlg::OnButtonDLPLogo() 
{
	ShowImage("DLPLOGO.bmp");
}

BOOL CD1100DemoDlg::ShowImage(LPCTSTR lpFilename) 
{
	
	if (!m_D1100.IsDeviceAttached ())
	{
		AfxMessageBox (_T("Error communicating with the Discovery 1100"));
		return FALSE;
	}
	else
	{
		// load image into memory buffer m_pFrameBuffer in DMD compatible format
		m_D1100.LoadImageFileToBuffer(lpFilename,m_pFrameBuffer,0);
		// transfer image from memory buffer to ActiveX control buffer
		m_D1100.LoadFrameBuffer(m_pFrameBuffer);
		// load and reset to display the image
		m_D1100.LoadResetFrame ();	// display the image
	}

	return TRUE;
	
}


void CD1100DemoDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}
